import networkx as nx
import matplotlib.pyplot as plt

def page_rank(G: nx.DiGraph,iterations=10,d=0.85):
    N = G.number_of_nodes()
    #Two pagerank dictionaries exist to first update all PRs from the old values
    #Then update the old ones to the new ones.
    PR = {}
    PR_OLD = {}
    for n in G.nodes():
        #PR_0 of all nodes is 1/|V|
        PR[n] = 1/N
        #Add edges from sinks to every other node, including itself
        if G.out_degree(n) == 0:
            for v in G.nodes():
                G.add_edge(n,v)
    PR_OLD = PR.copy()
        
    for i in range(iterations):
        for n in G.nodes:
            total = 0
            for (incoming_node,this_node) in G.in_edges(n):
                total += PR_OLD[incoming_node]/G.out_degree(incoming_node)
            PR[n] = (1-d)/N + d*total
        difference = [PR[i]/PR_OLD[i] for i in PR]
        PR_OLD = PR.copy()
    return(PR,i)

G = nx.DiGraph()
G.add_edges_from([
    (0,1),
    (2,1)
])
print(page_rank(G,100000))